
/*!
*************************************************************************************
* \file  mfc_dec.c
*
* \brief 
*        MFC SDK  decoder layer interface to JM decoder
*
* \author 
*    Main contributors
*        - Hariharan Ganapathy   (hari.ganapathy@dolby.com)
*
*
*************************************************************************************
*/


#include "c3d_decoder_layer_api.h"
#include "mfc_dec.h"


void* allocate_mfc_decoder_wrapper(){          
    
   
    return(allocate_mfc_decoder_layer());

}

int initialize_mfc_decoder_wrapper(void *pv_dec_lyr_ctxt,void  *init_params){            

    return(initialize_mfc_decoder_layer(pv_dec_lyr_ctxt,(RPUData *)init_params));

}

  int processDecRpuWrapper(
                        void    *pv_dec_layer_context,
                const    void    *pv_recon_bl,
                        void    *pv_pred_el                        
                        )
{
    int status = 0;


    status = process_dec_rpu(pv_dec_layer_context,
                        (ImageData *)pv_recon_bl,                                             
                        (ImageData *)pv_pred_el                                                
                        );



                    
     
    return status;

}
    
int   process3DDeMuxWrapper(void    *pv_dec_layer_context,
                            void    *pv_view0_image,
                            void    *pv_view1_image,
                    const    void   *pv_bl_image,
                    const    void   *pv_el_image,                        
                    const    void   *pv_predel_image,
                            int     deMuxMode
                        )
{
    int status = 0;

if(deMuxMode==1)
{
    status = process3DDeMux_OM(pv_dec_layer_context,
                        (ImageData *)pv_view0_image,
                        (ImageData *)pv_view1_image,
                        (ImageData *)pv_bl_image,
                        (ImageData *)pv_el_image,
                        (ImageData *)pv_predel_image
                        );
}
else
{
        status = process3DDeMux_FC(pv_dec_layer_context,
                        (ImageData *)pv_view0_image,
                        (ImageData *)pv_view1_image,
                        (ImageData *)pv_bl_image                        
                        );                
}

     
    return status;

}


int32_t free_mfc_decoder_wrapper(void  *pv_dec_layer_ctxt){        
    
    free_mfc_decoder_layer(pv_dec_layer_ctxt);       


    return 0;

}





